'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _babelCore = require('babel-core');

var _elementTree = require('./elementTree');

var Parser = (function () {
    function Parser() {
        _classCallCheck(this, Parser);

        this._strictModeEnabled = true;
    }

    _createClass(Parser, [{
        key: 'isStrictModeEnabled',
        value: function isStrictModeEnabled() {
            return this._strictModeEnabled;
        }
    }, {
        key: 'enableStrictMode',
        value: function enableStrictMode() {
            this._strictModeEnabled = true;
        }
    }, {
        key: 'disableStrictMode',
        value: function disableStrictMode() {
            this._strictModeEnabled = false;
        }
    }, {
        key: 'parse',
        value: function parse(code) {
            var ast = this._parseAst(code);
            var tokens = this._processTokens(ast, code);
            return (0, _elementTree.buildElementTree)(ast, tokens);
        }
    }, {
        key: '_parseAst',
        value: function _parseAst(code) {
            var comments = [];
            var tokens = [];
            var opts = {
                onToken: tokens,
                onComment: comments,
                strictMode: this._strictModeEnabled
            };
            var ast = (0, _babelCore.parse)(code, opts);
            ast.tokens = tokens;
            ast.comments = comments;
            return ast;
        }
    }, {
        key: '_processTokens',
        value: function _processTokens(ast, code) {
            return (0, _elementTree.buildTokenList)(ast.tokens, ast.comments, code);
        }
    }]);

    return Parser;
})();

exports['default'] = Parser;
module.exports = exports['default'];